/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 *
 *  Copyright (C) 2009-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  @(#) $Id: chip_pcb.h 1067 2014-12-24 14:15:10Z ertl-honda $
 */

/*
 *  ץå¸ץåȥ֥å⥸塼MPCOREѡ
 */
#ifndef TOPPERS_CHIP_PCB_H
#define TOPPERS_CHIP_PCB_H

#include "mpcore.h"

/*
 *  ¸⥸塼ARMѡ
 */
#include "arm_gcc/common/core_pcb.h"

#ifndef TOPPERS_MACRO_ONLY

/*
 *  MPCore¸ץåȥ֥å
 */
typedef struct target_processor_control_block{
	/*
	 *  ߥϥɥơ֥ؤΥݥ
	 */
	const FP* p_inh_tbl;

	/*
	 *  ARM¸ץåȥ֥å
	 */
	APCB arm_pcb;

#ifdef USE_GIC_CPULOCK
	/*
	 * ͥ٤ޥѿ
	 */
	uint8_t saved_iipm;

	/*
	 * CPUåե饰ͤݻѿ
	 */
	bool_t lock_flag;
#endif /* USE_GIC_CPULOCK */
}TPCB;

/*
 *  åη
 */
typedef uint32_t LOCK;

#ifdef USE_THREAD_ID_PCB

#define OMIT_GET_MY_P_PCB

Inline PCB*
get_my_p_pcb(void)
{
	PCB* my_p_pcb;
	uint32_t tmp;

	CPU15_PONLY_THREAD_ID_READ(tmp);
	my_p_pcb = (PCB*)tmp;

	return my_p_pcb;
}
#endif /* USE_THREAD_ID_PCB */

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_CHIP_PCB_H */
